$! GROUP_FOR_USER.COM
$! 02-10-1995, David Mathog, Biology Division, Caltech
$!
$! This replaces usernames by the appropriate group name in any
$! file that has usernames down the first column.
$! It works only if
$! each group and user name has a unique identifier in the SYSUAF,
$! and if these match the ones on the Unix machine.
$!
$! P1 is input file, if present, otherwise, default is SUMMINUTE
$! P2 is output file, if present, otherwise, default is input file
$!
$!
$ if("''P1'" .nes. "")
$ then
$   modfile = P1
$ else
$   modfile = "SUMMINUTE"
$ endif
$ if("''P2'" .nes. "")
$ then
$   outfile = P2
$ else
$   outfile = modfile
$ endif
$ open/read tfil: 'modfile'
$ open/write ofil: temp.dat
$!
$top:
$   read/end=bye/error=oops tfil: string 
$   user = f$extract(0,8,string)
$   user = f$edit(user,"COLLAPSE,UPCASE")
$   x = f$identifier(user,"name_to_number")
$   if(x .ne. 0)
$   then
$     x = ((x .and. %xFFFF0000) .or. %xFFFF)
$     group = f$identifier(x,"number_to_name")
$     group = group + "        "
$     group = f$extract(0,8,group)
$   else
$     group = "unknown "
$   endif
$   string = group + f$extract(8,2000,string)
$   write ofil: string
$ goto top
$!
$bye:
$ close tfil:
$ close ofil:
$ write sys$output "Almost done, cleaning up..."
$ copy temp.dat 'outfile'
$ delete temp.dat.
$ exit
$!
$error:
$ close tfil:
$ close ofil:
$ write sys$output "Error reading ''modfile'"
$ write sys$output "deleting temporary file temp.dat"
$ delete temp.dat.
$ exit
